Loading...
Searching...
No Matches
Sip_subject

## Macros

#define | sip_subject(sip)
| Access a SIP Subject header structure sip_subject_t from sip_t.
#define | SIP_SUBJECT_INIT()
| Initializer for structure sip_subject_t.
#define | SIPTAG_SUBJECT(x)
| Tag list item for pointer to a Subject header structure sip_subject_t.
#define | SIPTAG_SUBJECT_REF(x)
| Tag list item for reference to a Subject header pointer.
#define | SIPTAG_SUBJECT_STR(s)
| Tag list item for string with Subject header value.
#define | SIPTAG_SUBJECT_STR_REF(x)
| Tag list item for reference to a Subject header string.

## Typedefs

typedef struct msg_generic_s | sip_subject_t
| @

## Functions

issize_t | sip_subject_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Subject header.
issize_t | sip_subject_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Subject header.
sip_subject_t * | sip_subject_init (sip_subject_t x[1])
| Initialize a structure sip_subject_t.
int | sip_is_subject (sip_header_t const *header)
| Test if header object is instance of sip_subject_t.
sip_subject_t * | sip_subject_dup (su_home_t *home, sip_subject_t const *hdr))
| Duplicate a list of Subject header header structures sip_subject_t.
sip_subject_t * | sip_subject_copy (su_home_t *home, sip_subject_t const *hdr))
| Copy a list of Subject header header structures sip_subject_t.
sip_subject_t * | sip_subject_make (su_home_t *home, char const *s))
| Make a Subject header structure sip_subject_t.
sip_subject_t * | sip_subject_format (su_home_t *home, char const *fmt,...)))
| Make a Subject header from formatting result.

## Variables

msg_hclass_t | sip_subject_class []
| Header class for Subject header.
tag_typedef_t | siptag_subject
| Tag for Subject header object.
tag_typedef_t | siptag_subject_str
| Tag for string with Subject header value.

## Detailed Description

## Macro Definition Documentation

## SIP_SUBJECT_INIT

#define SIP_SUBJECT_INIT | ( |  | ) |

Initializer for structure sip_subject_t.

A static sip_subject_t structure for Subject header must be initialized with the SIP_SUBJECT_INIT() macro. For instance,

sip_subject_t sip_subject = SIP_SUBJECT_INIT;
sip_subject_t
struct msg_generic_s sip_subject_t
@
Definition sip.h:192
SIP_SUBJECT_INIT
#define SIP_SUBJECT_INIT()
Initializer for structure sip_subject_t.
Definition sip_protos.h:5384
sip_subject
#define sip_subject(sip)
Access a SIP Subject header structure sip_subject_t from sip_t.
Definition sip_protos.h:5367

## SIPTAG_SUBJECT

#define SIPTAG_SUBJECT | ( |  | x | ) |

Tag list item for pointer to a Subject header structure sip_subject_t.

The SIPTAG_SUBJECT() macro is used to include a tag item with a pointer to a sip_subject_t structure in a tag list.

Parameters

  x | pointer to a sip_subject_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_SUBJECT_REF().

## SIPTAG_SUBJECT_STR

#define SIPTAG_SUBJECT_STR | ( |  | s | ) |

Tag list item for string with Subject header value.

The SIPTAG_SUBJECT_STR() macro is used to include a tag item with a string containing value of a sip_subject_t header in a tag list.

Parameters

  s | pointer to a string containing Subject header value, or NULL.

The string in SIPTAG_SUBJECT_STR() can be converted to a sip_subject_t header structure by giving the string s has second argument to function sip_subject_make().

The corresponding tag taking reference parameter is SIPTAG_SUBJECT_STR_REF().

## Typedef Documentation

## sip_subject_t

typedef struct msg_generic_s sip_subject_t

@

The Subject header provides a summary or indicates the nature of the request. Its syntax is defined in RFC 3261 as follows:

Subject = ( "Subject" / "s" ) HCOLON [TEXT-UTF8-TRIM]

The parsed Subject header is stored in sip_subject_t structure.

The structure sip_subject_t contains representation of a SIP Subject header.

The sip_subject_t is defined as follows:

typedef struct msg_generic_s
{
msg_common_t g_common[1]; // Common fragment info
msg_generic_t *g_next; // Link to next header
char const *g_string; // Subject text
} sip_subject_t;
msg_common_t
struct msg_common_s msg_common_t
msg_generic_s
msg_generic_s::g_common
msg_common_t g_common[1]
msg_generic_s::g_string
char const * g_string
msg_generic_s::g_next
msg_generic_t * g_next

## Function Documentation

## sip_is_subject()

int sip_is_subject | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_subject_t.

Check if the header class is an instance of Subject header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header subject
  0 | (false) otherwise

## sip_subject_copy()

sip_subject_t * sip_subject_copy | ( | su_home_t * | home,
|  | sip_subject_t const * | hdr )

inline

Copy a list of Subject header header structures sip_subject_t.

The function sip_subject_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  subject = sip_subject_copy(home, sip->sip_subject);
  sip_subject_copy
  sip_subject_t * sip_subject_copy(su_home_t *home, sip_subject_t const *hdr))
  Copy a list of Subject header header structures sip_subject_t.
  Definition sip_protos.h:5514

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_subject_dup()

sip_subject_t * sip_subject_dup | ( | su_home_t * | home,
|  | sip_subject_t const * | hdr )

inline

Duplicate a list of Subject header header structures sip_subject_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  subject = sip_subject_dup(home, sip->sip_subject);
  sip_subject_dup
  sip_subject_t * sip_subject_dup(su_home_t *home, sip_subject_t const *hdr))
  Duplicate a list of Subject header header structures sip_subject_t.
  Definition sip_protos.h:5471

Returns
  A pointer to the newly duplicated sip_subject_t header structure, or NULL upon an error.

## sip_subject_format()

sip_subject_t * sip_subject_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Subject header from formatting result.

Make a new sip_subject_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_subject_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_subject_init()

sip_subject_t * sip_subject_init | ( | sip_subject_t | x[1] | ) |

inline

Initialize a structure sip_subject_t.

An sip_subject_t structure for Subject header can be initialized with the sip_subject_init() function/macro. For instance,

sip_subject_t sip_subject;
sip_subject_init(&sip_subject);
sip_subject_init
sip_subject_t * sip_subject_init(sip_subject_t x[1])
Initialize a structure sip_subject_t.
Definition sip_protos.h:5402

## sip_subject_make()

sip_subject_t * sip_subject_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Subject header structure sip_subject_t.

The function sip_subject_make() makes a new sip_subject_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_subject_t header structure, or NULL upon an error.

## Variable Documentation

## sip_subject_class

msg_hclass_t sip_subject_class[]

extern

Header class for Subject header.

The header class sip_subject_class defines how a SIP Subject header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_subject_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.